/* BLITALNC.C  - Blit fucntion, byte aligned no conversion, no clipping
 *
 * Atari Graphics Library
 * Shawn Jefferson
 * 
 * December 18, 2002
 */

#include <atari.h>
#include <string.h>
#include "atarigfx.h"


/* blit_aligned_nc
 *
 * Blit from the source bitmap to the destination bitmap.  This function
 * assumes that the graphics modes of the bitmap is the same and that the
 * source and destination locations are byte aligned.  Basically we are
 * just doing a memcpy from one bitmap to another.
 */
void __fastcall__ blit_aligned_nc(BITMAP *src, BITMAP *dest, int sx, int sy, int dx, int dy, int w, int h)
{
  unsigned char i;
  unsigned char bsx, bdx;               // byte sx and dx position
  unsigned char bw;                     // width in bytes


  bsx = (unsigned char) (sx / PIXELS_PER_BYTE(src->mode));
  bdx = (unsigned char) (dx / PIXELS_PER_BYTE(dest->mode));
  bw  = (unsigned char) (w / PIXELS_PER_BYTE(src->mode)); 

  for (i=0; i < h; i++) {
    memcpy( &dest->dat[((dy+i) * BYTES_PER_LINE(dest) + bdx)], &src->dat[((sy+i) * BYTES_PER_LINE(src)) + bsx], bw);
  }

  return;
}
