/* BMPCLEAR.C  -  Clear bitmap functions
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * May 30, 2002
 */

#include <atari.h>
#include <string.h>
#include "atarigfx.h"
#include <stdio.h>


const unsigned char bmpclear_4c_mask[3] = {0x55, 0xAA, 0xFF};



/* clear_bitmap_to
 *
 * Clear a bitmap to a specific color (color register 0-4)
 */
void __fastcall__ clear_bitmap_to(BITMAP *bmp, unsigned char creg)
{
  unsigned int bytes;
  unsigned char c;



  bytes = (bmp->bpl * bmp->h);

  switch(PIXELS_PER_BYTE(bmp->mode)) {
    case 1:
      c = creg;
      break;

    case 2:
      c = (creg | (creg << 4));
      break;

    case 4:
      if (creg == 4)
	c = 0;
      else
	c = bmpclear_4c_mask[creg];
      break;

    case 8:
      if (creg == 4)
	c = 0;
      else
	c = 0xFF;
      break; 
  } 

  memset(bmp->dat, c, bytes);
  return;
}


/* clear_bitmap
 *
 * Clears the bitmap to the background color.
 */
void __fastcall__ clear_bitmap(BITMAP *bmp)
{
  clear_bitmap_to(bmp, BAKCOL(bmp->mode));
  return;
}
