/* BMPLOAD.C  -  Bitmap load function
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * May 30, 2002
 */

#include <atari.h>
#include <stdio.h>
#include "atarigfx.h"



/* load_bitmap_pic
 *
 * Loads an uncompressed .pic file into the specified bitmap.  Returns 0 if
 * file not found, 1 if data was loaded from the file.  Note that this routine
 * expects the bitmap width to be normal (screen size) for the mode.  This
 * function does not currently set the color registers.  This function 
 * doesn't do clipping!
 */
unsigned char __fastcall__ load_bitmap_pic(BITMAP *bmp, char *filename)
{
  FILE *pic;
  unsigned char *buf;
  unsigned char lines;


  //*** Open the file ***//
  pic = fopen(filename, "rb");
  if (!pic) return(0);

  //*** FIXME: Clip? ***//

  lines = 0;
  while(!feof(pic) && (lines < bmp->h)) {
    buf = bmp->dat + (bmp->bpl * lines);
    fread(buf, sizeof(char), bmp->bpl, pic);
    lines++;
  }

  fclose(pic);
  return(1);
} 
