/* PLOT2CLC.C  -  Plot function, 2 color mode, clipping
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * December 11, 2002
 */

#include <atari.h>
#include "atarigfx.h"



/* plot_2colmode
 *
 * Plots a point on the bitmap using the passed in color register.  This
 * function does clipping.
 */
void __fastcall__ plot_2colmode(BITMAP *bmp, int x, int y, unsigned char creg)
{
  unsigned char bit;
  unsigned char data;
  unsigned int index;


  if ((x < 0) || (y < 0) || (x >= bmp->w) || (y >= bmp->h))
    return;

  bit  = (x % 8);
  index = (bmp->bpl * y) + (x / 8);

  data = bmp->dat[index];

  if (creg == BAKCOL(bmp->mode)) {              // background color?
    data &= ~plot2cmask[bit];                   // clear pixel instead
  }
  else
    data |= plot2cmask[bit];                    // set pixel

  bmp->dat[index] = data;
  return;
}
