/* PLOT2CLN.C  -  Plot function, 2 color mode, no clipping
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * December 11, 2002
 */

#include <atari.h>
#include "atarigfx.h"



/* plot_2colmode_nc
 *
 * Plots a point on the bitmap using the passed in color register.  This
 * function does no clipping, so you have to watch the parameters you pass
 * in.
 */
void __fastcall__ plot_2colmode_nc(BITMAP *bmp, unsigned int x, unsigned int y, unsigned char creg)
{
  unsigned char bit;
  unsigned char data;
  unsigned int index;


  bit  = (x % 8);
  index = (bmp->bpl * y) + (x / 8);

  data = bmp->dat[index];

  if (creg == BAKCOL(bmp->mode)) {              // background color?
    data &= ~plot2cmask[bit];                   // clear pixel instead
  }
  else
    data |= plot2cmask[bit];                    // set pixel

  bmp->dat[index] = data;
  return;
}
