/* PLOT4CLN.C  -  Plot function, 4 color mode, no clipping
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * December 11, 2002
 */

#include <atari.h>
#include "atarigfx.h"



/* plot_4colmode_nc
 *
 * Plots a point on the bitmap using the passed in color register.  This
 * function does no clipping, so you have to watch the parameters you pass
 * in.
 */
void __fastcall__ plot_4colmode_nc(BITMAP *bmp, unsigned int x, unsigned int y, unsigned char creg)
{
  unsigned char bit;
  unsigned char data;
  unsigned int index;


  bit  = (x % 4);
  index = (bmp->bpl * y) + (x / 4);

  data = bmp->dat[index];
  data &= plot4cmask[bit];                      // clear the pixel first

  if (creg != BAKCOL(bmp->mode)) {              // not background color?
    data |= ((creg+1) << plot4cshift[bit]);     // creg 0->01, 1->10, 2->11
  }

  bmp->dat[index] = data;
  return;
}
