/* PLOTGTC.C  -  Plot function, gtia mode, clipping
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * January, 22, 2003
 */

#include <atari.h>
#include "atarigfx.h"



/* plot_gtiamode
 *
 * Plots a point on the bitmap using the passed in color register (depending
 * on mode this may be a fixed color or luminance value.  This function does
 * clipping if the bitmap has clipping turned on.
 */
void __fastcall__ plot_gtiamode(BITMAP *bmp, int x, int y, unsigned char creg)
{
  unsigned int index;
  unsigned char bit;
  unsigned char data;


  if ((x < 0) || (y < 0) || (x >= bmp->w) || (y >= bmp->h))
    return;

  bit  = (x % 2);                              // pixel in byte
  index = (bmp->bpl * y) + (x / 2);            // index into bitmap
  data = bmp->dat[index];

  if (bit == 0)                                // clear the pixel first 
    data &= 0x0F;
  else
    data &= 0xF0;

  if (bit == 0)                                // set the pixel
    data |= (creg << 4); 
  else
    data |= creg;

  bmp->dat[index] = data;
  return;
}
