/* PLOTGTN.C  -  Plot function, gtia mode, no clipping
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * January, 22, 2003
 */

#include <atari.h>
#include "atarigfx.h"



/* plot_gtiamode_nc
 *
 * Plots a point on the bitmap using the passed in color register (depending
 * on mode this may be a fixed color or luminance value.  This function does
 * clipping if the bitmap has clipping turned on.
 */
void __fastcall__ plot_gtiamode_nc(BITMAP *bmp, unsigned int x, unsigned int y, unsigned char creg)
{
  unsigned char bit;
  unsigned char data;
  unsigned int index;


  bit  = (x % 2);                              // pixel in byte
  index = (bmp->bpl * y) + (x / 2);            // index into bitmap
  data = bmp->dat[index];

  if (bit == 0)                                // clear the pixel first 
    data &= 0x0F;
  else
    data &= 0xF0;

  if (bit == 0)                                // set the pixel
    data |= (creg << 4); 
  else
    data |= creg;

  bmp->dat[index] = data;
  return;
}
