/* PMACTIVA.C  -  Set active pmarea
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * March 13, 2002
 */

#include <atari.h>
#include "atarigfx.h"



/* set_active_pmarea
 *
 * Sets the active player missile area, by setting PMBASE with the address
 * of the pmarea.  We also set the line resolution of the pmarea at SDMCTL
 * DMACTL shadow (559)  We haven't turned on DMA for player/missile graphics
 * yet.  That is done in init_pmgraphics.
 *
 * SDMCTL:  bit 5 - pm graphics resolution, 0 = double, 1 = single
 */
void __fastcall__ set_active_pmarea(PMAREA *pmarea)
{
  PMBASE = ((unsigned int) &pmarea->dat[0]) / 256;

  if (pmarea->mode == PM_1LINE)
    SDMCTL |= 16;
  else
    SDMCTL &= ~16;

  return;
}



