/* PMDESTRO.C  -  Destroy player missile area
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * March 13, 2003
 */

#include <atari.h>
#include <stdlib.h>
#include "atarigfx.h"


extern void __fastcall__ _heapadd(void *mem, size_t size);



/* destroy_pmarea
 *
 * Frees all memory associated with the pmarea.
 */
void __fastcall__ destroy_pmarea(PMAREA *pmarea)
{
  //*** Free pmarea minus the unused portion at beginning ***//
  if (pmarea->mode == PM_2LINE)
    _heapadd(pmarea->dat + 384, 1024 - 384);        // 1k 
  else
    _heapadd(pmarea->dat + 768, 2048 - 768);        // 2k

  return;
}

