/* PMINIT.C  -  Initialize player missile graphics
 *
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * March 13, 2003
 */

#include <atari.h>
#include "atarigfx.h"



/* init_pmgraphics
 *
 * Initializes player missile graphics.  Turns on player and missile graphics
 * via DMACTL shadow (559) and GRACTL (53277).  You must have set the active
 * pmarea, or you will most likely see garbage on the screen.  If you want to
 * activate only players, or only missiles you will have to change the values
 * yourself.
 *
 * SDMCTL: bit 2 - missile DMA on
 *         bit 3 - player DMA on
 *
 * GRACTL: bit 0 - turn on missiles
 *         bit 1 - turn on players
 */
void init_pmgraphics(void)
{
  SDMCTL |= 12;                             // enable P & M DMA
  GRACTL = 3; 

  return;
}

