/* TEST.C  -  Drawing function benchmark routines
 *
 * Shawn Jefferson
 * September 4, 2003
 */

#include <atari.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "atarigfx.h"

#define RTCLOCK0    *(unsigned char *) 20
#define RTCLOCK1    *(unsigned char *) 19



int main()
{
  BITMAP *bmp1;
  unsigned int i;
  unsigned int x, y;
  unsigned char c;


  RTCLOCK1 = 0;

  //*** 4 color mode testing ***//
  bmp1 = create_bitmap(0x0E, 160, 192);
  if (!bmp1) return(0);

  printf("\nTesting 4 color bitmap:\n");

  RTCLOCK0 = 0;
  i = 0;
  printf("clear bitmap     - ");
  while (RTCLOCK0 < 120) {
    clear_bitmap(bmp1);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  x = rand() % 160;
  y = rand() % 192;
  c = rand() % 4;
  RTCLOCK0 = 0;
  i = 0;
  printf("plot, no clip    - ");
  while (RTCLOCK0 < 120) {
    plot_4colmode_nc(bmp1, x, y, c);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  RTCLOCK0 = 0;
  i = 0;
  printf("plot, with clip  - ");
  while (RTCLOCK0 < 120) {
    plot_4colmode(bmp1, x, y, c);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  RTCLOCK0 = 0;
  i = 0;
  printf("textout, w/ clip - ");
  while (RTCLOCK0 < 120) {
    textout_4colmode(bmp1, sysfont, "Hello World!", 0, 0, 1);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  RTCLOCK0 = 0;
  i = 0;
  printf("textout, no clip - ");
  while (RTCLOCK0 < 120) {
    textout_4colmode_nc(bmp1, sysfont, "Hello World!", 0, 0, 1);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  destroy_bitmap(bmp1);

  //*** 2 color mode testing ***//
  bmp1 = create_bitmap(0x0F, 320, 192);
  if (!bmp1) return(0);

  printf("\nTesting 2 color bitmap:\n");
  RTCLOCK1 = 0;

  RTCLOCK0 = 0;
  i = 0;
  printf("clear bitmap    - ");
  while (RTCLOCK0 < 120) {
    clear_bitmap(bmp1);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  x = rand() % 320;
  y = rand() % 192;
  RTCLOCK0 = 0;
  i = 0;
  printf("plot, no clip   - ");
  while (RTCLOCK0 < 120) {
    plot_2colmode_nc(bmp1, x, y, 1);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  RTCLOCK0 = 0;
  i = 0;
  printf("plot, with clip - ");
  while (RTCLOCK0 < 120) {
    plot_2colmode(bmp1, x, y, 1);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  //destroy_bitmap(bmp1);

  //*** GTIA color mode testing ***//
  printf("\nCreating gtia mode bitmap.\n");
  //bmp1 = create_bitmap(0x11, 80, 192);
  bmp1->mode = 0x11;
  bmp1->w    = 80;

  printf("\nTesting GTIA mode:\n");
  RTCLOCK1 = 0;

  RTCLOCK0 = 0;
  i = 0;
  printf("clear bitmap    - ");
  while (RTCLOCK0 < 120) {
    clear_bitmap(bmp1);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  x = rand() % 80;
  y = rand() % 192;
  RTCLOCK0 = 0;
  i = 0;
  printf("plot, no clip   - ");
  while (RTCLOCK0 < 120) {
    plot_gtiamode_nc(bmp1, x, y, 8);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  RTCLOCK0 = 0;
  i = 0;
  printf("plot, with clip - ");
  while (RTCLOCK0 < 120) {
    plot_gtiamode(bmp1, x, y, 8);
    i++;
  }
  printf("%d per second.\n", (i / 2));

  destroy_bitmap(bmp1);

  cgetc();
  return(0);
}
