/* TOUTHELP.C  -  Textout helpers
 * 
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * May 30, 2002
 */

#include <atari.h>
#include <string.h>



/* atascii_to_internal
 *
 * Converts an atascii character set value to an internal character set
 * value.
 */
char __fastcall__ atascii_to_internal(char c)
{
  if (c < 32)
    return(c + 64);
  else if (c < 96)
    return(c - 32);
  else
    return(c);
}


/* str_to_internal
 *
 * Converts a string from atascii code to internal character set code.
 * Usually we want to do this before writing it to a bitmap.
 */
void __fastcall__ str_to_internal(char *s)
{
  unsigned int i;
  unsigned int len;


  len = strlen(s);
  for(i = 0; i < len; i++) {
    if (s[i] < 32)
      s[i] += 64;
    else if (s[i] < 96)
      s[i] -= 32;

  }

  return;
}
