/* TOUTTXTN.C  -  Textout textmode no clipping
 * 
 * Atari Graphics Library
 * Shawn Jefferson
 *
 * May 30, 2002
 */

#include <atari.h>
#include <stdlib.h>
#include <string.h>
#include "atarigfx.h"



/* textout_textmode_nc
 *
 * Writes text into bitmap without clipping.  Only use this function with
 * the text modes, and make sure you are not clobbering memory beyond your
 * bitmap.  Color of the text is controlled through different means (color
 * registers and/or character set.)  Font will be the system font which is
 * controlled through CHBAS (756)
 */
void __fastcall__ textout_textmode_nc(BITMAP *bmp, const char *s, int x, int y)
{
  char *ts;                     // temporary string


  //*** Allocate temporary string storage ***//
  ts = (char *) malloc(sizeof(char) * (strlen(s) + 1));
  if (!ts) {
    return;
  }
  strcpy(ts, s);
  str_to_internal(ts);

  memcpy(bmp->dat + ((bmp->w * y) + x), ts, strlen(s));

  free(ts);
  return;
}
